package de.unikoblenz.fgbks.base.utils.boundary.creater;

import de.unikoblenz.fgbks.base.utils.boundary.AbstractGrowingBoundary;
import de.unikoblenz.fgbks.base.utils.boundary.BoundType;
import java.util.Optional;

public class CreaterUpper extends AbstractBoundaryCreater<AbstractGrowingBoundary> {

  private static final CreaterUpper instance = new CreaterUpper();

  private CreaterUpper() {
    super();
  }

  public static CreaterUpper getInstance() {
    return instance;
  }

  @Override
  public BoundaryCreaterType getType() {
    return BoundaryCreaterType.UPPER;
  }

  @Override
  public Optional<AbstractGrowingBoundary> create(AbstractGrowingBoundary b) {
    if (b.getUpperBound().equals(b.getMaxValue())) {
      return Optional.empty();
    }
    return Optional.of(
        b.getCopy(
            b.getUpperBound(),
            b.getMaxValue(),
            b.getUpperBoundType().getOp(),
            BoundType.INCLUSIVE));
  }
}
